<?php

class modJSRTagCloudHelper
{
	function getContents($section, $params = null)
	{
        $out = array();
		$out[$section]['items'] = modJSRTagCloudHelper::getTags($section, $params);
		$out[$section]['name'] = modJSRTagCloudHelper::getSectionName($section);
		return $out;
	}

	function getTags($section, $params)
	{
		$db = JFactory::getDBO();
		
		$where = array();
		
		if($params->get('depends_on_user') && $uid = JRequest::getVar('user_id', 0))
		{
		    $where[] =  " h.user_id = {$uid} ";
		}
		
		$where['client'] = ' r.client_id = 0';
	    if($params->get('depends_on_group') /*&& $client = JRequest::getVar('client', 0)*/)
		{
		    $client_id = JRequest::getInt('client_id');
            if(!$client_id 
            && JRequest::getString('option', false, 'GET') == 'com_community' 
            && JRequest::getString('layout', false, 'GET') == 'group'
            && JRequest::getString('id', false, 'GET')
            )
            {
                $client_id = JRequest::getString('id', false, 'GET');
            }
            if($client_id)
    		    $where['client'] = ' r.client_id = '.$client_id;
		}
		
	    // normal time artilcles
		if($params->get('time_period', "default_time") == "default_time"){
			$where[] = "( (r.extime = '0000-00-00 00:00:00' OR r.extime > NOW()) AND r.ctime < NOW() )";
		} 
		// old expired articles
		else if( $params->get('time_period') == 'expired_time'){
			$where[] = "(r.extime < NOW() AND r.extime <> '0000-00-00 00:00:00')";
		}
		// future time articles
		else if( $params->get('time_period') == 'future_time'){
			$where[] = "(r.ctime > NOW())";
		}
		
		if(!$params->get('relevance_mode'))
		{
			$total = ' SUM(h.hits) AS total ';
		}
		else
		{
			$total = ' COUNT(r.id) AS total ';
		}
		
		$where[] = "r.published = 1 AND h.section_id = $section";
		
		$where = implode(' AND ', $where);
		
		$sql = "SELECT {$total}, t.tag, t.slug, t.id, rc.catid, r.client, r.client_id
		FROM #__js_res_tags AS t
		LEFT JOIN #__js_res_tags_history AS h ON h.tag_id = t.id
		LEFT JOIN #__js_res_record AS r ON r.id = h.record_id
		LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = h.record_id
		WHERE $where
		GROUP BY t.id
		ORDER BY total DESC";

		if($params->get('limit') > 0)
		{
			$sql .= ' LIMIT 0, '.$params->get('limit');
		}
		$db->setQuery($sql);
		$tags = $db->loadObjectList();
		
		if(!$tags) return array();
		
		$html = explode(",", $params->get('html1', 'H1, H2, H3, H4, H5, H6, strong, b, em, big, small'));
		$html_tags = count($html)-1;
		
		$tags_max = $tags[0]->total;
		$tags_min = $tags[count($tags) - 1]->total;
		$step = ($tags_max - $tags_min) / $html_tags;
		if($step == 0) $step = 1;

		foreach ($tags AS $i => $tag)
		{
			$tags[$i]->index = abs(floor(($tags_max - $tag->total) / $step));
			if($params->get('show_totals'))
			{
				$tags[$i]->tag .= " ({$tag->total})";
			}
		}
		shuffle($tags);
		return $tags;
	}

	function getSectionName($section)
	{
		$db = & JFactory::getDBO();
		$sql = "SELECT name FROM #__js_res_category WHERE id = {$section}";
		$db->setQuery($sql);
		return  $db->loadResult();
	}
}

?>