<?php

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
require_once (dirname(__FILE__).DS.'helper.php');

$db = JFactory::getDBO();

$section 	= $params->get('default_section', 'default'); 
$type 		= $params->get('default_type', 'default');
$author 	= $params->get('show_author', 'name');

$category_ids = array();
if( $section != 'default' ) {
	$category_ids[] = $section;
	getChildren($section, $category_ids);	
}

$sql = 	"SELECT r.title, r.ctime, r.id, t.name AS type_name, u.username, u.name, c.name AS cat_name, c.id AS catid, t.id AS type_id FROM #__js_res_record AS r "		
		."\n LEFT JOIN #__js_res_record_category AS rc ON rc.record_id=r.id"
		."\n LEFT JOIN #__js_res_category AS c ON c.id = rc.catid"
		."\n LEFT JOIN #__js_res_types AS t ON r.type_id = t.id"		
		."\n LEFT JOIN #__users AS u ON r.user_id = u.id"
		."\n WHERE r.published = 1 AND c.published=1 ";

if( $section != 'default'){
	$sql .= 'AND rc.catid IN('.implode(',', $category_ids).')';
}

		
if( $type != 'default') 
	$sql .= " AND t.id = ".intval($type);
		
$sql .=  "\nORDER BY r.ctime DESC ";

if( $params->get('limit') != 0 )
	$sql .= " LIMIT 0, ".$params->get('limit', 10);
		
$result = $db->setQuery($sql);
$articles_list = $db->loadObjectList($result);

$show_type 		= $params->get('show_type', 1);
$show_category 	= $params->get('show_category', 1);

/*
echo "<pre>";
print_r($db->_sql);
echo "</pre>";
*/
?>
<table class="adminlist">
<thead>
	<tr>
		<td class="title"><strong><?php echo JText::_('Latest Articles'); ?></strong></td>
		<?php if( $show_category ):?><td><strong><?php echo JText::_('Category'); ?></strong></td><?php	endif;?>
		<?php if($show_type):?><td><strong><?php echo JText::_('Type'); ?></strong></td><?php endif; ?>
		<td class="title"><strong><?php echo JText::_('Created'); ?></strong></td>
		<td class="title"><strong><?php echo JText::_('Author'); ?></strong></td>
	</tr>
</thead>	
<?php if(count($articles_list) > 0) : 
		foreach($articles_list AS $article){
			$link 		= "index.php?option=com_resource&view=record&task=edit&cid[]=".$article->id;
			$cat_link 	= "index2.php?option=com_resource&controller=category&task=edit&cid[]=".$article->catid;
			$type_link 	= "index2.php?option=com_resource&controller=type&task=edit&cid[]=".$article->type_id;
		?><tr>
			<td><a href="<?php echo $link; ?>"><?php  echo htmlspecialchars($article->title, ENT_QUOTES, 'UTF-8'); ?></a></td>
			<?php if( $show_category ): ?><td><a href="<?php echo $cat_link; ?>"><?php echo $article->cat_name; ?></a></td><?php endif; ?>
			<?php if($show_type):?><td><a href="<?php echo $type_link; ?>"><?php echo $article->type_name; ?></a></td><?php endif; ?>
			<td><?php echo JHTML::_('date', $article->ctime, '%Y-%m-%d %H:%M:%S'); ?></td>			
			<td><?php echo ($author == 'name') ? $article->name : $article->username; ?></td>
		</tr>
		<?php
		}
	endif; ?>
</table>